<?php

namespace Teknisa\FIN\Modules\ContaPagar\Controllers;

use Zeedhi\Framework\DTO;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response;
use Doctrine\ORM\EntityManager;
use Teknisa\FIN\Modules\ContaPagar\Services\Pag20000ControleRateioContasPagarService;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request\Row;

class Pag20000ControleRateioContasPagarController {

    public function __construct(Environment $environment ,Pag20000ControleRateioContasPagarService $pag20000ControleRateioContasPagarService)
        {
            $this->environment  = $environment;
            $this->Pag20000ControleRateioContasPagarService = $pag20000ControleRateioContasPagarService;
        }
        
    public function salvarRateio(Row $row, Response $response)
        {
            try {
                
                $row = $row->getRow();
                
                $this->Pag20000ControleRateioContasPagarService->salvarRateio($row);
                
                $response->addDataSet(new DataSet('salvarRateio', ['success' => 'S']));
            } catch (\Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
            }
        }
        
    public function updateRateio(Row $row, Response $response)
        {
            try {
                
                $row = $row->getRow();
                $this->Pag20000ControleRateioContasPagarService->updateRateio($row);
                
                $response->addDataSet(new DataSet('updateRateio', ['success' => 'S']));
            } catch (\Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
            }
        }
        
    public function deleteRateio(Row $row, Response $response)
        {
            try {
                
                $row = $row->getRow();
                
                $this->Pag20000ControleRateioContasPagarService->deleteRateio($row["DELETADO"],$row["DATA"]);
                
                $response->addDataSet(new DataSet('deleteRateio', ['success' => 'S']));
            } catch (\Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
            }
        }
}