<?php

namespace Teknisa\FIN\Modules\ContaReceber\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\Controller\Report;

/**
 * Class EmissaoBoletoController
 * @package Teknisa\FIN\Modules\ContaReceber\Controllers
 */
class EmissaoBoletoController extends Report{

    protected $qr2Strategy;
    protected $environment;

    public function __construct($reportService, $qr2Strategy) {
        $this->qr2Strategy                  = $qr2Strategy;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'Modelo_Banrisul' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'MODELO_SICREDI' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),


        'ModBolComp_Santander' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'MODELOBOL_BRADESCO' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBol_Santander' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBolComp' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'modelobolcomp_banrisul' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'MODELOBOLCOMITAU' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBolComp_SICOOB' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBolCompCaixa' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBolCompPort' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBolCompSafra' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBolComp_Santander' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'MODELOBOLCOMP_ITAU' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBolScb_Brasil' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),
            
        'ModeloBolDaycoval' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),
            
            'ModeloBol_Btg' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            )

    );
    
    //Função responsável por chamar o método createRemoteReport conforme padrão do BIRT
    
    public function generateReport(DTO\Request\Row $request, DTO\Response $response) {
        /**
        * Foi necessário utilizar o controller pois a URL tem que retornar, uma vez que,
        * na rotina de envio de boleto por e-mail e automatizado necessíta salvar o arquivo PDF.
        */
        
        $row = $request->getRow();
       
        $reportMapping = array(
                'CDFILIAL' => $row["CDFILIAL"],
                'NRLANBOLREC' => $row["NRLANBOLREC"],
                'NRORG' => $row["NRORG"],
                "__format" => 'pdf'
            );
        
        // Nessa função foi necessário passar o true como ultimo parâmetro para geração da URL do BIRT
        $birtURL = $this->reportService->createRemoteReport('BIRT', $row['__report_name'], $reportMapping, true);
         
        $response->addMessage(new DTO\Response\Message($birtURL));
       
    }

}