<?php

namespace Teknisa\FIN\Modules\ContaReceber\Controllers;

use Teknisa\FIN\Controllers\TeknisaCrud;
use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\FIN\Modules\ContaReceber\Services\Rec22000HistoricoRenegociacaoFinanceiraService;

class Rec22000HistoricoRenegociacaoFinanceiraController {
    
    protected $entityManager;
    protected $environment;
    protected $service;
    
    public function __construct(EntityManager $entityManager, Environment $environment, Rec22000HistoricoRenegociacaoFinanceiraService $service) {
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
        $this->service       = $service;
    }
    
     public function excluirRenegociacao(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $cdfilialnf = $row['CDFILIALNF'];
            $nrlanctonf = $row['NRLANCTONF'];
            
            $this->service->getRenegociacao($row, $cdfilialnf, $nrlanctonf);
        }
        catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
} 