/* Tabela EXPAUTFILIAL: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela EXPAUTFILIAL */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela EXPAUTFILIAL, utilizando
a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_ADM_EXPAUTFILIAL
AFTER DELETE OR INSERT OR UPDATE
ON EXPAUTFILIAL FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;

  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';
   IF DELETING THEN

      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'Filial=' || :OLD.CDFILIAL;
      END IF;

      IF :OLD.CDRELATEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' ArqExpor=' || :OLD.CDRELATEXP;
      END IF;

      IF :OLD.NMARQTXTEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' NomeArq=' || :OLD.NMARQTXTEXP;
      END IF;

      IF :OLD.DSDIRARQEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' Diretorio=' || :OLD.DSDIRARQEXP;
      END IF;

      IF :OLD.NRDIAARQEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' DiaGeracao=' || :OLD.NRDIAARQEXP;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDFILIAL || :OLD.CDRELATEXP;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL    <> :NEW.CDFILIAL)    OR
            (:OLD.CDRELATEXP  <> :NEW.CDRELATEXP)  OR
            (:OLD.NMARQTXTEXP <> :NEW.NMARQTXTEXP) OR
            (:OLD.DSDIRARQEXP <> :NEW.DSDIRARQEXP) OR
            (:OLD.NRDIAARQEXP <> :NEW.NRDIAARQEXP) THEN

            V_TIPO         := '2';
            V_CDFILLOGOPER := :OLD.CDFILIAL;
            V_ITPESQ       := :OLD.CDFILIAL || :OLD.CDRELATEXP;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_CDFILLOGOPER := :NEW.CDFILIAL;
         V_ITPESQ       := :NEW.CDFILIAL || :NEW.CDRELATEXP;
      END IF;

      IF :NEW.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'Filial=' || :NEW.CDFILIAL;
      END IF;

      IF :NEW.CDRELATEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' ArqExpor=' || :NEW.CDRELATEXP;
      END IF;

      IF :NEW.NMARQTXTEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' NomeArq=' || :NEW.NMARQTXTEXP;
      END IF;

      IF :NEW.DSDIRARQEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' Diretorio=' || :NEW.DSDIRARQEXP;
      END IF;

      IF :NEW.NRDIAARQEXP IS NOT NULL THEN
         V_DESC := V_DESC || ' DiaGeracao=' || :NEW.NRDIAARQEXP;
      END IF;

   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('EXPAUTFILIAL',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_ADM_EXPAUTFILIAL','4.09.060'); END;
/

