/* Sistemas Integrados TEKNISA
  Integrao TEKNISA X SAP

Nome: 0008_LAVFUNO.SQL

@C:\web_565\sql\end_conv\oracle\clientes\lav\0008_LAVFUNO.SQL

Descrio:
Rotina responsvel por retornar o cdigo reduzido referente a conta contbil
cadastrada na tela Parametrizao Contbil (Conta Estoque)  SAP

Criao:
19/04/2012 - Jefferson de Melo Gouvea
*/

CREATE OR REPLACE FUNCTION USR_CODREDUCC_LAVOR(
   P_CDFILIAL	IN FILIAL.CDFILIAL%TYPE,
   P_NRLANCTONF	IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CDCONTCTBL	IN CONTCTBL.CDCONTCTBL%TYPE,
   P_TIPO	IN NOTAFISCAL.IDENTRSAIDOP%TYPE) RETURN VARCHAR
IS
   V_IDENTRSAIDOP  VARCHAR2(01);
   V_CDTIPOOPER    VARCHAR2(02);
   V_IDTPIJURNF    VARCHAR2(01);

   V_CDCONTIMPO    VARCHAR2(02);
   V_CDCONTACTB    VARCHAR2(20);
   V_EXISTEIMPNF   VARCHAR2(02);

   V_RESULT        VARCHAR2(20);
BEGIN
   V_IDENTRSAIDOP := NULL;
   V_CDTIPOOPER   := NULL;
   V_IDTPIJURNF   := NULL;

   V_CDCONTIMPO   := NULL;
   V_CDCONTACTB   := NULL;

   V_EXISTEIMPNF  := NULL;

   V_RESULT := NULL;

   SELECT MAX(CDCONTCTBL)
     INTO V_CDCONTACTB
     FROM CONTCTBL
    WHERE CDCONTREDU = P_CDCONTCTBL;


   SELECT MAX(IDENTRSAIDOP), MAX(CDTIPOOPER), MAX(IDTPIJURNF)
     INTO V_IDENTRSAIDOP, V_CDTIPOOPER, V_IDTPIJURNF
     FROM NOTAFISCAL
    WHERE CDFILIAL = P_CDFILIAL
      AND NRLANCTONF = P_NRLANCTONF;

   /* Verifica conta contbil de imposto por tipo de operao */
   BEGIN
      SELECT MAX(CDIMPOSTO)
        INTO V_CDCONTIMPO
        FROM CTBIMPTPOPER
       WHERE IDENTRSAIDOP = V_IDENTRSAIDOP
         AND CDTIPOOPER = V_CDTIPOOPER
         AND ((CDCCTBDESPTO = V_CDCONTACTB) OR
              (CDCCTBPASSTO = V_CDCONTACTB) OR
              (CDCCTBATIVTO = V_CDCONTACTB));
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDCONTIMPO := NULL;
   END;

   IF V_CDCONTIMPO IS NULL THEN
      BEGIN
         SELECT MAX(CDIMPOSTO)
           INTO V_CDCONTIMPO
           FROM CCTBIMPFORN
          WHERE IDTPIJURIMPO = V_IDTPIJURNF
            AND ((CDCCTBDESPIF = V_CDCONTACTB) OR
                 (CDCCTBPASSIF = V_CDCONTACTB) OR
                 (CDCCTBATIVIF = V_CDCONTACTB));
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDCONTIMPO := NULL;
      END;

      IF V_CDCONTIMPO IS NULL THEN
         BEGIN
            SELECT MAX(CDIMPOSTO)
              INTO V_CDCONTIMPO
              FROM IMPOSTO
             WHERE ((CDCCTBLDESP = V_CDCONTACTB) OR
                    (CDCCTBLPASS = V_CDCONTACTB) OR
                    (CDCCTBLATIV = V_CDCONTACTB));
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDCONTIMPO := NULL;
         END;
      END IF;
   END IF;

   SELECT MAX(CDIMPOSTO)
     INTO V_EXISTEIMPNF
     FROM ITEMPROIMPOS
    WHERE CDFILIAL = P_CDFILIAL
      AND NRLANCTONF = P_NRLANCTONF
      AND CDIMPOSTO = V_CDCONTIMPO;

   IF V_EXISTEIMPNF IS NULL THEN

      IF P_TIPO = 'D' THEN
         IF V_IDENTRSAIDOP = 'E' THEN
            SELECT MAX(CDCONTREDU)
              INTO V_RESULT
              FROM NOTAFISCAL NF, CONTCTBL CTB, USR_CONTSAP SAP
             WHERE NF.CDFILIAL     = P_CDFILIAL
               AND NF.NRLANCTONF   = P_NRLANCTONF
               AND NF.CDFILIRECE   = SAP.USR_CDFILIAL
               AND NF.CDTIPOOPER   = SAP.USR_CDTIPOOPER
               AND NF.IDENTRSAIDOP = SAP.USR_IDENTRSAID
               AND CTB.CDCONTCTBL  = SAP.USR_CDCONTCTBLPROD;
         ELSE
            SELECT MAX(CDCONTREDU)
              INTO V_RESULT
              FROM NOTAFISCAL NF, CONTCTBL CTB, USR_CONTSAP SAP
             WHERE NF.CDFILIAL     = P_CDFILIAL
               AND NF.NRLANCTONF   = P_NRLANCTONF
               AND NF.CDFILIEMIT   = SAP.USR_CDFILIAL
               AND NF.CDTIPOOPER   = SAP.USR_CDTIPOOPER
               AND NF.IDENTRSAIDOP = SAP.USR_IDENTRSAID
               AND CTB.CDCONTCTBL  = SAP.USR_CDCONTCTBLPROD;
         END IF;
      ELSE
         IF V_IDENTRSAIDOP = 'E' THEN
            SELECT MAX(CDCONTREDU)
              INTO V_RESULT
              FROM NOTAFISCAL NF, CONTCTBL CTB, USR_CONTSAP SAP
             WHERE NF.CDFILIAL     = P_CDFILIAL
               AND NF.NRLANCTONF   = P_NRLANCTONF
               AND NF.CDFILIRECE   = SAP.USR_CDFILIAL
               AND NF.CDTIPOOPER   = SAP.USR_CDTIPOOPER
               AND NF.IDENTRSAIDOP = SAP.USR_IDENTRSAID
               AND CTB.CDCONTCTBL  = SAP.USR_CDCONTCTBLINSC;
         ELSE
            SELECT MAX(CDCONTREDU)
              INTO V_RESULT
              FROM NOTAFISCAL NF, CONTCTBL CTB, USR_CONTSAP SAP
             WHERE NF.CDFILIAL     = P_CDFILIAL
               AND NF.NRLANCTONF   = P_NRLANCTONF
               AND NF.CDFILIEMIT   = SAP.USR_CDFILIAL
               AND NF.CDTIPOOPER   = SAP.USR_CDTIPOOPER
               AND NF.IDENTRSAIDOP = SAP.USR_IDENTRSAID
               AND CTB.CDCONTCTBL  = SAP.USR_CDCONTCTBLINSC;
         END IF;
      END IF;
   END IF;

   IF V_RESULT IS NULL THEN
      RETURN(P_CDCONTCTBL);
	ELSE
      RETURN(V_RESULT);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_CODREDUCC_LAVOR','5.65.XXX'); END;
/

