/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SERVPADR                                                 */
/* Tabela : SERVPADR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SERVPADR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_SERVPADR
GO

CREATE TRIGGER DTULTATU_SERVPADR
ON SERVPADR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SERVPADR', null, 'CDSERVPADR=' + CDSERVPADR + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SERVPADR
      SET DTULTATUSRVP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(SERVPADR.CDSERVPADR,0) = ISNULL(INSERTED.CDSERVPADR,0)) AND
            (ISNULL(SERVPADR.NMSERVPADR,0) = ISNULL(INSERTED.NMSERVPADR,0)) AND
            (ISNULL(SERVPADR.CDPRODUTO,0)  = ISNULL(INSERTED.CDPRODUTO,0));
   END;
END;
GO

