function Rec22000_HistoricoRenegociacaoFinanceira_Controller(ZhFilterPreferences, templateManager, ScreenService, General) {
    
    /**
     * Variáveis de Inicialização
     **/
     
    var self = this;
    
    /**
     * Abertura do Filtro de Relatório
     * @param widget 
     */
     
    self.openFilterRelatorio = function(widget){
        ZhFilterPreferences.openFilterWidget(widget);
    };
    
    self.filterRelatorio = function(widget, preference){
        var dtHistrenegofin = preference.FILTER_ROW.DTHISTRENEGOFIN;
        var cdEmpresa = preference.FILTER_ROW.CDEMPRESA;
        var cdCliente = preference.FILTER_ROW.CDCLIENTE;

        widget.dataSourceFilter.forEach(function(filtro){
            switch(filtro.name){
                case 'CDEMPRESA':
                    filtro.value = cdEmpresa ? cdEmpresa.join("_"):cdEmpresa;
                break;
                case 'CDCLIENTE':
                    filtro.value = cdCliente ? cdCliente:null;
                break;
                case 'DTRENEGOINI':
                    filtro.value = dtHistrenegofin.start ? dtHistrenegofin.start : null;
                break;
                case 'DTRENEGOFIN':
                    filtro.value = dtHistrenegofin.end ? dtHistrenegofin.end : null;
                break;
            }
        });
        delete preference.FILTER_ROW.DTHISTRENEGOFIN;
        preference.CUSTOM_FILTER_ROW = {};
    };
    
    this.filtroFormulario = function(widget){
    	var cdcliente = templateManager.container.getWidget('rec22000_historico_renegociacao_financeira_grid').currentRow.CDCLIENTE;
    	var nrseqhistrenego = templateManager.container.getWidget('rec22000_historico_renegociacao_financeira_grid').currentRow.NRSEQHISTRENEGO;
    	
    	widget.dataSourceFilter = [
    			{
	                "name": "CDCLIENTE",
	                "operator": "=",
	                "value": cdcliente
    			},
    			{
	                "name": "NRSEQHISTRENEGO",
	                "operator": "=",
	                "value": nrseqhistrenego
    			}
    		];
    		widget.reload();
    	
    };
    
    this.filtroContaGeradas = function(widget){
    	var cdfilialnf = templateManager.container.getWidget('rec22000_historico_renegociacao_financeira_grid').currentRow.CDFILIALNF;
    	var nrlanctonf = templateManager.container.getWidget('rec22000_historico_renegociacao_financeira_grid').currentRow.NRLANCTONF;
    	
    	widget.dataSourceFilter = [
    			{
	                "name": "CDFILIALNF",
	                "operator": "=",
	                "value": cdfilialnf
    			},
    			{
	                "name": "NRLANCTONF",
	                "operator": "=",
	                "value": nrlanctonf
    			}
    		];
    		widget.reload();
    	
    };
    
    this.excluir = function(widget){
        widget = templateManager.container.getWidget('rec22000_historico_renegociacao_financeira_grid');
        var route = 'fin_contaReceber#/excluirRenegociacao';
        
        ScreenService.confirmMessage('Deseja realmente excluir o registro?', 'question', function(success) {
            General.callRestEngine(route, 'Row', widget.currentRow).then(function(success) {
                ScreenService.showMessage('Registro excluído com sucesso.');
                ScreenService.closeSwipe();
                widget.reload();
            }).catch(function(error){
                ScreenService.showMessage('Operação Bloqueada. Ocorreu um erro ao efetuar a operação!');
            });
        });
    };
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Rec22000_HistoricoRenegociacaoFinanceira_Controller', Rec22000_HistoricoRenegociacaoFinanceira_Controller);
});