function Pag01000_RelatorioPrevisaoDeJuros_Controller(ZhFilterPreferences) {
    
    /**
     * Variáveis de Inicialização
     **/
     
    var self = this;
    
    /**
     * Abertura do Filtro de Relatório
     * @param widget 
     */

    self.openFilterRelatorio = function(widget){
        ZhFilterPreferences.openFilterWidget(widget);
    };
    
    self.filterRelatorio = function(widget, preference){
        console.log(widget.dataSourceFilter);
        var cdEmpresa = preference.FILTER_ROW.CDEMPRESA;
        var cdForneced = preference.FILTER_ROW.CDFORNECED;
        var dtAtuavenpag = preference.FILTER_ROW.DTATUAVENPAG;
        var vrPerc = preference.FILTER_ROW.VRPERC;
        var cdIndice = preference.FILTER_ROW.CDINDICE;
        var dtRefe = preference.FILTER_ROW.DTREFE;
        
        if(cdEmpresa === undefined || cdEmpresa.length === 0){
            cdEmpresa = 'T';
        }else{
            cdEmpresa = cdEmpresa.join("_");
        }
        
        if(cdForneced === undefined || cdForneced.length === 0){
            cdForneced = 'T';
        }else{
            cdForneced = cdForneced.join("_");
        }
        
        widget.dataSourceFilter.forEach(function(filtro){
            switch(filtro.name){
                case 'CDEMPRESA':
                    filtro.value = cdEmpresa;
                break;
                case 'CDFORNECED':
                    filtro.value = cdForneced;
                break;
                case 'P_DATVENIN':
                    filtro.value = dtAtuavenpag.start;
                break;
                case 'P_DATVENFIN':
                    filtro.value = dtAtuavenpag.end;
                break;
                case 'DTREFE':
                    filtro.value = dtRefe?dtRefe:null;
                break;
                case 'VRPERC':
                    filtro.value = vrPerc?vrPerc:null;
                break;
                case 'CDINDICE':
                    filtro.value = cdIndice?cdIndice:null;
                break;
            }
        });
        if(widget.dataSourceFilter[0].name === 'DTATUAVENPAG'){
            delete widget.dataSourceFilter[0];
        }
        delete preference.FILTER_ROW.DTATUAVENPAG;
        preference.CUSTOM_FILTER_ROW = {};
    };
    
    self.AlteraCampos = function(widget){
        var porcentagem = widget.getField('VRPERC');
        var indice = widget.getField('CDINDICE');
        
        if(widget.currentRow.VRPERC != null){
        indice.readOnly = true;
        porcentagem.readOnly = false;
        } else if (widget.currentRow.CDINDICE != null){
        porcentagem.readOnly = true;
        indice.readOnly = false;
        }
    };
    
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Pag01000_RelatorioPrevisaoDeJuros_Controller', Pag01000_RelatorioPrevisaoDeJuros_Controller);
});