package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.chrome.ChromeDriver;
import org.testng.Assert;

import java.sql.Driver;
import java.util.concurrent.TimeUnit;



public class TipoDeDebitoBancarioPage extends PageBase {


    By Financeiro = By.xpath("/html/body/span/section/section/div[2]/section[2]/div/section/section[2]/section/header/div/div/ul/li[1]/label/a");
    By MENU = By.xpath("//div[@class='bars']");
    By PARAMETRIZACAO = By.xpath("//span[contains(text(),'Parametrização')]");
    By FINANCEIRO = By.xpath("//li[@class='menu-item closed sub-menu-item has-child visible']//span[@class='menu-title ng-binding has-submenu'][normalize-space()='Financeiro']");


    By ElementoOperacional = By.xpath("//a[normalize-space()='Operacional']");

    By AplicarFiltro = By.cssSelector("#footer > div.zh-footer-right > ul > li > a > span");
    By BotaoAdicionar = By.cssSelector("#footer > div.zh-footer-center > ul > li > a > div");

    By BotaoProcurar = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[1]/section/input");

    By TipoDeDebitoBancario =  By.xpath("//*[text() = 'Tipo de Débito Bancário']");

    //Filtro
    By TipoDeDebitoBancario2 = By.cssSelector("#DSTPDEBIBANC");
    By OpcaoTipoDeDebitoBancario2 = By.xpath("//*[@id=\"popup\"]/span/section/section/section/div/form/section[1]/div/div[1]/div/div/div[3]/span[1]");

    By HistoricoPadrao = By.cssSelector("#DSHISTPADR");
    By OpcaoHistoricoPadrao = By.xpath("//*[@id=\"popup\"]/span/section/section/section/div/form/section[1]/div/div[2]/div[1]/div/div[3]/span[1]");

    By ContaContabil = By.cssSelector("#CDCONTCTBL");
    By OpcaoContaContabil = By.xpath("//*[@id=\"popup\"]/span/section/section/section/div/form/section[1]/div/div[2]/div[2]/div/div[3]/span[1]");

    By ClassFinanceira = By.cssSelector("#DSCLASSFINA");
    By OpcaoClassFinanceira = By.xpath("//*[@id=\"popup\"]/span/section/section/section/div/form/section[1]/div/div[3]/div[1]/div/div[3]/span[1]");

    By Contabiliza = By.xpath("//*[@id=\"popup\"]/span/section/section/section/div/form/section[1]/div/div[3]/div[2]/div/div[2]");
    By ContabilizaOpcaoSim = By.xpath("//*[@id=\"popup\"]/span/section/section/section/div/form/section[1]/div/div[3]/div[2]/div/div[2]/ul/li[2]");

    By BotaoMaisCampos = By.xpath("//*[@id=\"popup\"]/span/section/section/section/div/form/section[2]/label/span[2]");

    By BotaoAplicarFiltro = By.xpath("//*[@id=\"footer\"]/div[3]/ul/li/a/span");

    // Adicionar o Tipo de Debito Bancario

    By ClicarAdcionar = By.xpath("//*[@id=\"footer\"]/div[2]/ul/li/a/div");

    By Codigo = By.cssSelector("#CDTPDEBIBANC");

    By Nome = By.cssSelector("#DSTPDEBIBANC");

    By Salvar = By.xpath("//*[@id=\"footer\"]/div[3]/ul/li/a/span");


    public void navegarTipoDeDebitoBancario(String ProcurarTDB) {
        waitForElement(Financeiro);
        waitForElement(MENU);
        click(MENU);
        click(BotaoProcurar);
        clear(BotaoProcurar);
        sendKeys(BotaoProcurar, ProcurarTDB);
        click(TipoDeDebitoBancario);
    }

    public void Filtro() {

        click(TipoDeDebitoBancario2);
        click(OpcaoTipoDeDebitoBancario2);

        click(HistoricoPadrao);
        click(OpcaoHistoricoPadrao);

        click(ContaContabil);
        click(OpcaoContaContabil);

        click(ClassFinanceira);
        click(OpcaoClassFinanceira);

        click(Contabiliza);
        click(ContabilizaOpcaoSim);

        click(BotaoMaisCampos);
        click(BotaoAplicarFiltro);

    }

    public void AdicionarTipoDeDebitoBancario(String CodigoTDB, String NomeTDB) {

        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);

        click(Codigo);
        clear(Codigo);
        sendKeys(Codigo, CodigoTDB);

        click(Nome);
        clear(Nome);
        sendKeys(Nome, NomeTDB);

        click(Salvar);

        driver.quit();
    }



    public void AlertaUsuario() throws InterruptedException {
        this.driver.manage().timeouts().implicitlyWait(1, TimeUnit.MINUTES);
        driver.findElement(By.cssSelector("body > span > section > section > div.default-window > aside:nth-child(5) > aside > section > footer > button:nth-child(1)")).click();
    }

}






