package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ApuracaoImpostoICMSSTFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.ApuracaoImpostoICMSSTPage;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class ApuracaoImpostoICMSST extends TestBase {

    // Objetos

    MainPage mainPage;
    LoginPage loginPage;
    MainFlows MainFlows;
    ApuracaoImpostoICMSSTFlows ApuracaoImpostoICMSSTFlows;
    ApuracaoImpostoICMSSTPage ApuracaoImpostoICMSSTPage;

    // Teste

    @Test
    public void efetuarLoginComSucesso() throws InterruptedException {

        //Objetos Instanciados

        mainPage = new MainPage();
        loginPage = new LoginPage();
        MainFlows = new MainFlows();
        ApuracaoImpostoICMSSTFlows = new ApuracaoImpostoICMSSTFlows();
        ApuracaoImpostoICMSSTPage =  new ApuracaoImpostoICMSSTPage();

        // Dados - Login

        String usuario = "operador24@AUTOMACAO_2184.com";
        String senha = "apresentacao";


        // Dados - Filtro Da Tela

        String tipodeapuracao = "Municipal";
        String empresa = "HELA INGREDIENTES BRASIL";
        String imposto = "80 - ICMS-ST";
        String inscricaoestadual = "35800712";


        // Dados - Inserção do Mapa de Apuração

        String nomedomapa = "Apuração de ICMS-ST";
        String datafinal = "31/01/2021";


        // *** Dados a Serem Inseridos Na Aba ( Arrecadação Fiscal ) ***

        String VencimentoArrecFiscal = "01012070";
        String CodigoDaReceita = "3001";
        String ValorDeJuros = "20";


        // *** Dados a Serem Inseridos Na Aba ( Guias Complementares ) ***

        String CodObrigacao = "10001";
        String ValorBaseCalculo = "100";
        String ValorDaReceita = "1000";
        String VencGuiaCompl = "01012070";
        String DescricaoGuiaComp = "Guia Complementar Do Teste De Automação";
        String NumProcesso = "007007";


        // *** Dados a Serem Inseridos Na Aba ( Informações Adicionais ) ***

        String CodigoInfo = "30001";
        String DescricaoInformacao = "Informações Adicionais do ICMS ST";
        String ValorInfAdic = "3500";


                // ..........Teste Da Tela..........


        // !!!! LOGIN !!!!

        loginPage.preenhcerUsuario(usuario);
        loginPage.preencherSenha(senha);
        loginPage.clicarEmLogin();


        // !!! MENU !!!

        MainFlows.navegarParaApuracaoDeImposto();


        // !!! FILTRO DE APURAÇÃO !!!

        ApuracaoImpostoICMSSTPage.clicarEmTipodeapuracao();
        ApuracaoImpostoICMSSTPage.clicarEmEmpresa();
        ApuracaoImpostoICMSSTPage.clicarEmImposto();
        ApuracaoImpostoICMSSTPage.clicarEmInscricaoMunicipal();
        ApuracaoImpostoICMSSTPage.clicarAplicarFiltro();


        // !!! ADICIONAR MAPA !!!

        ApuracaoImpostoICMSSTPage.clicarAdicionarMapa();


        // !!! CRIANDO MAPA DE APURAÇÃO !!!

        ApuracaoImpostoICMSSTPage.preencherNomedomapa(nomedomapa);
        ApuracaoImpostoICMSSTPage.clicarsalvarMapa();


        // !!! APURAÇÃO DO MAPA !!!

       // ApuracaoImpostoICMSSTPage.clicarEmMapaApuracao();
        ApuracaoImpostoICMSSTPage.clicarEmAcoes();
        ApuracaoImpostoICMSSTPage.clicarEmApurar();
        ApuracaoImpostoICMSSTPage.clicarOk();


        // !!! ABA ARRECADAÇÃO FISCAL !!!

        ApuracaoImpostoICMSSTPage.clicarNaAbaArrecadacaoFiscal();
        ApuracaoImpostoICMSSTPage.clicarEmEditar();
        ApuracaoImpostoICMSSTPage.preencherVencimentoArrecadacaoFis(VencimentoArrecFiscal);
        ApuracaoImpostoICMSSTPage.preencherCodDaReceita(CodigoDaReceita);
        ApuracaoImpostoICMSSTPage.preencherVrDeJuros(ValorDeJuros);
        ApuracaoImpostoICMSSTPage.clicarEmSalvar();


        // !!! ABA GUIAS COMPLEMENTARES !!!

        ApuracaoImpostoICMSSTPage.clicarNaAbaGuiaComplementar();
        ApuracaoImpostoICMSSTPage.clicarEmAdicionar();
        ApuracaoImpostoICMSSTPage.preencherCodigoObrigacao(CodObrigacao);
        ApuracaoImpostoICMSSTPage.clicarEmCodigoDaReceita();
        ApuracaoImpostoICMSSTPage.preencherVrBaseDeCalculo(ValorBaseCalculo);
        ApuracaoImpostoICMSSTPage.preencherVrReceita(ValorDaReceita);
        ApuracaoImpostoICMSSTPage.preencherVencimentoGuiaCompl(VencGuiaCompl);
        ApuracaoImpostoICMSSTPage.preencherDescricaoGuiaCompl(DescricaoGuiaComp);
        ApuracaoImpostoICMSSTPage.preencherNumDoProcesso(NumProcesso);
        ApuracaoImpostoICMSSTPage.clicarEmSalvar();


        // !!! ABA INFORMAÇÕES ADICIONAIS !!!

        ApuracaoImpostoICMSSTPage.clicarNaAbaInformacoesAdicionais();
        ApuracaoImpostoICMSSTPage.clicarEmAdicionar();
        ApuracaoImpostoICMSSTPage.preencherCodInformacao(CodigoInfo);
        ApuracaoImpostoICMSSTPage.preencherDescInformacao(DescricaoInformacao);
        ApuracaoImpostoICMSSTPage.preencherValorInfoAdicional(ValorInfAdic);
        ApuracaoImpostoICMSSTPage.clicarEmSalvar();


        // *** Deletar Mapa ICMS-ST ***

        ApuracaoImpostoICMSSTPage.clicarEmVoltar();
        ApuracaoImpostoICMSSTPage.clicarEmMapaApuracao();
        ApuracaoImpostoICMSSTPage.clicarEmExcluir();
        ApuracaoImpostoICMSSTPage.clicarEmSim();
        ApuracaoImpostoICMSSTPage.clicarOk();

    }
}
